// serial.h

#ifndef _SERIAL_H
#define _SERIAL_H

#define CLOCK			24000000L

#define XMODEM_SERIAL_CH	0

// serial port access
#define NO_OF_SCI_CHANNELS	5

// prescaler n = 0
#define	BAUD(B)				( ( CLOCK / 1 / 16 / B ) - 1 )

#define LINEFEED			10
#define CARRIAGE_RETURN		13
#define ESCAPE				27
#define BACKSPACE			8

// status info
#define OK					0
#define ERROR				1
#define TIMEOUT				2

#define TX_IN_PROGRESS		1
#define TX_NOT_IN_PROGRESS	0

// function prototypes
void InitSci ( void );
void EnableTxInterrupt( void );
void DisableTxInterrupt( void );
void EnableTxEndInterrupt( void );
void DisableTxEndInterrupt( void );
void SendByte ( unsigned char b );
void SendString ( char* str );
void PurgeComms (unsigned long timeout );
void SendLFCR( void );
static void ClearSCITxFlag( void );
static unsigned char RxByteWaiting ( void );
static unsigned char TxByteEmpty ( void );
static void TxByteLoad( unsigned char b );
unsigned short GetByte ( unsigned long timeout );

// structure definitions
union union_c2s {
		unsigned char uc[2];		//	m16c
									//	uc[0] -> lsb (b7--b0)
									//	uc[1] -> msb (b15--b8)
		unsigned short us;
};

#endif
