// flash_header.h

#ifndef _FLASH_HEADER_H

typedef unsigned short read_datum;
#define BLANK_VALUE 				0xFFFF
#define MAX_FLASH_ADDR				0xFC000
#define NO_OF_FLASH_BLOCKS			11
#define FLASH_LINE_SIZE 			16

#define BLANK						1
#define NOT_BLANK					2
#define PROG_PASS					0x01
#define PROG_FAIL					0x02
#define ERASE_PASS					0x01
#define ERASE_FAIL					0x02

// commands
#define BLOCK_ERASE					0x20
#define READ_STATUS_REGISTER		0x70
#define PROGRAM_CMD					0x40

// function locations in pointer table
#define ERASEBLOCK_OFFSET			0
#define PROGRAM_OFFSET				1

union char_rd_datum_union {
	unsigned char c[FLASH_LINE_SIZE];
	read_datum u[FLASH_LINE_SIZE / sizeof (read_datum)];
};

struct rom_data {
	unsigned long start_address;
	unsigned long data_length;
	unsigned char data[584];
};

unsigned char BlockErase( unsigned long BlockNum, unsigned short *Dummy );
unsigned char Program_128_Bytes( unsigned long Address, unsigned short *Data );

#endif

