// main.c

#include <intrinsics.h>
#include "iom16c62p.h"
#include "delay_timer.h"

void main( void )
{
	unsigned char Dir = 0;
	unsigned long tick_count;
	
	// initialise the LED IO port
	PD2 = 0xFF;
	P2 = 1;
	
	InitDelayTimer();
	
	__enable_interrupt();
	
	while( 1 )
	{
		// delay for 200ms
		tick_count = 200 / MS_PER_TIMER_COMPARE_MATCH;
		StartDelayTimer();	
		while ( tick_count )
		{
			if ( GetDelayTimerStatus() )
			{
				StopDelayTimer();
				if ( --tick_count )
				{
					StartDelayTimer();
				}
			}
		}
		
		if( Dir == 0 )
		{
			P2 = P2 << 1;
			if( P2 == 0x80 )
			{
				Dir = 1;
			}
		}
		else
		{
			P2 = P2 >> 1;
			if( P2 == 0x01 )
			{
				Dir = 0;
			}
		}
	}	
}
